package momoko.compiler;

import momoko.*;
import momoko.util.*;
import momoko.protoclass.*;
import java.util.*;
import java.io.*;

/**
 * 
 */
public class JavaCompiler extends OOCompiler
{

public JavaCompiler()
{
  super();
  file_extension=".java";
}

public void set_scope(String pkg)
{
System.out.println("set_scope: "+out);
      out.println("package "+pkg+";");
}

public void import_library(String base, String thing)
{
  out.println("import "+base+"."+thing+";");
}

public void class_header(String classname, String parent)
{
      out.print("public class "+classname+" extends "+parent);
      out.println("{");
}

public void instance_variable(String type, String name)
{
  out.println(Database.main.types.classname(type)+" "+name+";");
}

public void constructor_header(String classname)
{
      out.println("public "+classname+"()");
      out.println("{");
      out.println("this(\"\");");
      out.println("}\n");
      out.println("public "+classname+"(String name)");
      out.println("{");
      out.println("super(name);");
}

public void initialize_instance_variable(String name, Property value)
{
  assignment_statement(name,print(value));
}

public void constructor_footer()
{
      method_footer();
      out.println("\n");
}

public void method_header(String name, String returntype, Vector args)
{
        out.print("public "+Database.main.types.classname(returntype)+" "+name+"(");
        Enumeration it=args.elements();
        if(it.hasMoreElements())
        {
          p=(Pair)it.nextElement();
          out.print(Database.main.types.classname((String)p.first)+" "+p.second);
        }
        while(it.hasMoreElements())
        {
          p=(Pair)it.nextElement();
          out.print(", "+Database.main.types.classname((String)p.first)+" "+p.second);
        }
        out.println(")");
        out.println("{");
}

public void return_statement(String to_return)
{
  out.println("return "+to_return+";");
}

public void assignment_statement(String to, String from)
{
        out.println(to+"="+from+";");
}

public void method_footer()
{
        out.println("}\n");
}

public void class_footer()
{
System.out.println("class footer");
  out.println("}");
}

}
