package momoko.extra;

import momoko.*;
import java.rmi.RemoteException;
import java.util.*;
import java.io.IOException;

public class Debugging extends MObject
{
  public Debugging()
  {
    this("");
  }

  public Debugging(String name)
  {
    super(name);
  }

  public void enterfunc(IMObject object)
  {
    try {
    subdir.remove(object.getName());
    Object dp=DebugProxy.newInstance(object);
    System.out.println("replacing "+object+" with "+dp);
    subdir.put(object.getName(), dp);
    } catch(Exception e) {e.printStackTrace();}
  }

  public void exitfunc(IMObject object)
  {
    System.out.println(object+" is exitting.");
  }

  public void remove(String name)
  {
    System.out.println(subdir);
    System.out.println("removing "+name);
    super.remove(name);
    System.out.println(subdir);
  }
}
