package momoko.forum;

import java.util.*;

public class OrderedSet extends HashSet
{
  Vector vector;

  public OrderedSet(Vector v) throws NullPointerException
  {
    super(v);
    vector=v;
  }

  public Iterator iterator()
  {
    return vector.iterator();
  }

  public boolean add(Object obj)
  {
    if(vector==null) vector=new Vector();
    vector.add(obj);
    return super.add(obj);
  }

  public boolean remove(Object obj)
  {
    vector.remove(obj);
    return super.remove(obj);
  }

  public void clear()
  {
    super.clear();
    vector=new Vector();
  }
}
