package momoko.server;

import java.util.*;
import momoko.*;
import momoko.stream.*;
import kawa.standard.Scheme;
import kawa.Shell;
import gnu.mapping.*;
import java.io.*;
import momoko.user.*;


public class SchemeInterpreter extends Interpreter
{
  protected IAdmin avatar;
  protected boolean running=true;
  protected static boolean debug = false;
  protected Scheme scheme;

  public SchemeInterpreter()
  {
    super();
    scheme = new Scheme();
  }

  public void setavatar(IUser av)
  {
    avatar=(IAdmin)av;
  }

  public IMObject getavatar()
  {
    return avatar;
  }

  public boolean interpret(Object command)
  {
    try { ((momoko.forum.User)avatar).setLastActionTime(new Date()); }
    catch(Exception e) {}
    try
    {
      String args=(String)command;
      if(args==null) return true;
      if(args.equals("")) return true;
      if(args.equals("(exit)")) return false;
      try
      {
//        InPort in=new CharArrayInPort(args.toCharArray());
        OutPort out=new OutPort(handler.getOutputStream());
        OutPort err=new OutPort(handler.getOutputStream());
        OutPort.setOutDefault(out);
        OutPort.setErrDefault(err);
//        OutPort.setLogFile("log.out");
//        Shell.run(scheme, scheme.getEnvironment(), in, out, err);
        scheme.eval(args);
        out.flush();
      }
      catch(NullPointerException e)
      { e.printStackTrace(new PrintStream(handler.getOutputStream())); }
      catch(Exception e)
      {
        e.printStackTrace(new PrintStream(handler.getOutputStream()));
      }
    }
    catch(ClassCastException e) {return false;}
if(debug) System.out.println("running: "+running);
    return running;
  }

public void close() {if(debug) System.out.println("closing");running=false;}

}
