package momoko.server;

import java.io.*;
import momoko.*;
import java.util.*;
import momoko.stream.*;
import momoko.util.*;

public class WordParser extends Parser
{
  String[] str=new String[4];

  public WordParser() { super(); }

  public Object parse(InputStream in)
  {
    try
    {
      String s=readLine(in);
      if(s==null) return null;
      return doparse(s);
    } 
    catch(Exception e) {return null;}
  }

  static private String readLine(InputStream isr) throws Exception
  {
    char[] carr=new char[1];
    byte[] barr=new byte[1];
    int c=isr.read(barr);
    carr[0]=(char)barr[0];
    if(c==-1) {return null;}
    StringBuffer buff=new StringBuffer();
    while(c!=-1 && carr[0]!='\n')
    {
      if(carr[0]!='\r')
        buff.append(carr[0]);
      c=isr.read(barr);
      carr[0]=(char)barr[0];
    }
//System.out.println("buff: "+buff);
    return buff.toString();
  }

  static public String[] doparse(String s)
  {
    Vector v=StringUtils.split(s, " ");
      String[] sarr=new String[v.size()];
      for(int x=0; x<sarr.length; x++)
        sarr[x]=(String)v.elementAt(x);
      return sarr;
  }
}
