package momoko.straw;

import java.io.*;
import java.rmi.*;
import java.lang.reflect.*;

public interface StrawBroker extends Remote
{
  public Serializable lookup(String path) throws RemoteException, NoSuchMethodException;
  public Serializable call(Integer i, String name, Object objs) throws RemoteException, NoSuchMethodException, IllegalAccessException, InvocationTargetException;
  public Serializable checkAndConvert(Object o) throws RemoteException;
  public Object[] importArrayReference(StrawArrayReference ref) throws RemoteException;
}
