package momoko.user;

import java.util.*;
import momoko.*;
import momoko.util.*;

public class UserDatabase extends MObject
{
  Hashtable data=new Hashtable();
  transient Database db=Database.main;

  public UserDatabase(String name)
  {
    super(name);

adduser("God","God",(Admin)db.addobj("momoko.shared.Admin",db.root,"God"));
  }

  public boolean adduser(String name, String password, Admin avatar)
  {
    if(data.get(name)!=null)
      return false;
    data.put(name, new Pair(password, avatar));
    return true;
  }

  public boolean deluser(String name)
  {
    if(data.get(name)==null)
      return false;
    data.remove(name);
    return true;
  }

  public Admin validate(String name, String password)
  {
    Pair p=(Pair)data.get(name);

    if(p==null) return null;
    if(password.equals(p.first))
      return (Admin)p.second;
    return null;
  }

  public boolean exists(String name)
  {
    return data.get(name)!=null;
  }
}
