package momoko.util;

import java.util.*;
import momoko.stream.*;

public class PrintUtils
{
  static public void printObject(Object o)
  {
    System.out.println("Object: "+o);
    Class c=o.getClass();
    System.out.println("Class:  "+c);
    Class[] interfaces=c.getInterfaces();
    System.out.println("Interfaces:");
    for(int x=0;x<interfaces.length;x++)
      System.out.println("    "+interfaces[x]);
  }

  static public void printArray(String prefix, Object[] arr)
  {
    System.out.print(prefix);
    System.out.print("[");
    if(arr.length==0)
    {
      System.out.println("]");
      return;
    }
    for(int x=0;x<arr.length-1;x++)
      System.out.print(arr+", ");
    System.out.println(arr[arr.length-1]+"]");
  }
}
