package momoko.vfs;

import momoko.*;
import momoko.stream.*;
import momoko.protoclass.*;
import momoko.relationship.*;
import momoko.proxy.*;
import momoko.user.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.vfs.*;
import java.lang.reflect.*;
import java.beans.*;
import momoko.versioncontrol.*;

public class MObjectFile extends MObject implements IMObject, VirtualFile
{
  RealFile file;

public MObjectFile()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public MObjectFile(String newname)
{
  super(newname);
  file=new RealFile(newname);
}

public MObjectFile(File f, String newname)
{
  super(newname);
 file=new RealFile(f, newname);
}

public InputStream getInputStream()
{
  return file.getInputStream();
}

public OutputStream getOutputStream()
{
  return file.getOutputStream();
}

public boolean release(IMObject object)  
{
  return true;
}

public boolean accept(IMObject object)  
{
  return false;
}

public VirtualFile getFileView()
{
  return file;
}

public VirtualFile getDirectoryView()
{
  return null;
}

public IMObject create(String ppath, String path, String name) throws IllegalArgumentException, BadPathException
{
  throw new IllegalArgumentException();
}

public IMObject create(IProtoClass parent, String path, String name) throws IllegalArgumentException, BadPathException
{
  throw new IllegalArgumentException();
}

public IMObject resolve(String path) throws BadPathException
{
if(debug) System.out.println("resolving: "+path);
  String prefix, suffix, temp=null;
  int i;
  boolean done=false;
  Iterator iterator;
 
  i=path.indexOf('/');
  if(i==-1)
  {
    prefix=path;
    suffix="";
  }
  else if(i==0)
  {
    return Database.main.root.resolve(path.substring(1));
  }
  else
  {
    prefix = path.substring(0, i);
    suffix = path.substring(i+1);
  }
  throw new BadPathException(this.getName()+"/"+path);
}

public void remove(String str)
{
}

public void persistSelf()
{
}

}
