package momoko.extra;

import java.io.*;
import momoko.*;
import java.util.*;
import momoko.server.LineParser;
import momoko.util.*;

public class MOOParser extends LineParser
{
  public MOOParser() { super(); }

  public Object parse(InputStream buff)
  {
    try
    {
      String s=(String)super.parse(buff);
      if(s==null) return null;
      return doparse(s);
    }
    catch(Exception e) {e.printStackTrace(); return null;}
  }

  static public MOOArguments doparse(String s)
  {
      Vector v=StringUtils.split(s, " ");

      String command="", subject="", preposition="", object="";

      try
      {
        command=(String)v.elementAt(0);
        v.removeElementAt(0);
      }
      catch(ArrayIndexOutOfBoundsException e) {}
      try
      {
        subject=(String)v.elementAt(0);
        v.removeElementAt(0);
      }
      catch(ArrayIndexOutOfBoundsException e) {}
      try
      {
        preposition=(String)v.elementAt(0);
        v.removeElementAt(0);
      }
      catch(ArrayIndexOutOfBoundsException e) {}

      object=StringUtils.join(v, " ");
      return new MOOArguments(command, subject, preposition, object);
  }
}
