package momoko.extra;

import momoko.*;
import momoko.proxy.*;
import java.rmi.RemoteException;
import java.util.*;
import java.io.IOException;

public class Navigating extends MObject
{
  static public boolean debug=false;

  public Navigating()
  {
    this("");
  }

  public Navigating(String name)
  {
    super(name);
  }

  public void enterfunc(IMObject object)
  {
    try {
    subdir.remove(object.getName());
    subdir.put(object.getName(), makeNavigation(object));
    } catch(Exception e) {e.printStackTrace();}
  }


    public Object makeNavigation(IMObject obj)
    {
      Class[] i, i2;
      if(debug) System.out.println("Making Navigable for "+obj);
      i=obj.getClass().getInterfaces();
      i2=new Class[i.length+1];
      int x;
      for(x=0; x<i.length; x++)
      {
        i2[x]=i[x];
        if(debug) System.out.println("Has interface "+i[x]);
      }
      i2[x]=Navigable.class;
      return java.lang.reflect.Proxy.newProxyInstance(
        obj.getClass().getClassLoader(), i2, new NavigableProxy(obj, i2));
    }

  private class NavigableProxy extends DelegationProxy
  {
    public NavigableProxy(IMObject object, Class[] interfaces)
    {
      super(interfaces, Navigating.makeObjects(object, interfaces));
    }
  }

    static private Object[] makeObjects(Object object, Class[] interfaces)
    {
      Object[] carr=new Object[interfaces.length];
      int x;
      for(x=0;x<interfaces.length-1;x++)
      {
        carr[x]=object;
        if(debug) System.out.println(interfaces[x]+" <-> "+carr[x]);
      }
      carr[x]=new Navigation();
      if(debug) System.out.println(interfaces[x]+" <-> "+carr[x]);
      return carr;
    }

}
