package momoko.forum;

import javax.mail.*;

public interface IMessage extends Part
{
    public Address getSender() throws javax.mail.MessagingException;
    public   javax.mail.Address[] getFrom() throws
javax.mail.MessagingException;
    public   void setFrom() throws javax.mail.MessagingException;
    public   void setFrom(javax.mail.Address a) throws
javax.mail.MessagingException;
    public   void addFrom(javax.mail.Address[] a) throws
javax.mail.MessagingException;
    public   javax.mail.Address[]
getRecipients(javax.mail.Message.RecipientType a) throws
javax.mail.MessagingException;
    public javax.mail.Address[] getAllRecipients() throws
javax.mail.MessagingException;
    public   void setRecipients(javax.mail.Message.RecipientType a,
javax.mail.Address[] b) throws javax.mail.MessagingException;
    public void setRecipient(javax.mail.Message.RecipientType a,
javax.mail.Address b) throws javax.mail.MessagingException;
    public   void addRecipients(javax.mail.Message.RecipientType b,
javax.mail.Address[] c) throws javax.mail.MessagingException;
    public void addRecipient(javax.mail.Message.RecipientType c,
javax.mail.Address d) throws javax.mail.MessagingException;
    public javax.mail.Address[] getReplyTo() throws
javax.mail.MessagingException;
    public void setReplyTo(javax.mail.Address[] e) throws
javax.mail.MessagingException;
    public   java.lang.String getSubject() throws javax.mail.MessagingException;
    public   void setSubject(java.lang.String f) throws
javax.mail.MessagingException;
    public   java.util.Date getSentDate() throws javax.mail.MessagingException;
    public   void setSentDate(java.util.Date d) throws
javax.mail.MessagingException;
    public   java.util.Date getReceivedDate() throws javax.mail.MessagingException;
    public   javax.mail.Flags getFlags() throws javax.mail.MessagingException;
    public boolean isSet(javax.mail.Flags$Flag a) throws
javax.mail.MessagingException;
    public   void setFlags(javax.mail.Flags b, boolean d) throws
javax.mail.MessagingException;
    public void setFlag(javax.mail.Flags$Flag a, boolean f) throws
javax.mail.MessagingException;
    public int getMessageNumber();
    public javax.mail.Folder getFolder();
    public boolean isExpunged();
    public   javax.mail.Message reply(boolean d) throws
javax.mail.MessagingException;
    public   void saveChanges() throws javax.mail.MessagingException;
    public boolean match(javax.mail.search.SearchTerm c) throws
javax.mail.MessagingException;
    public   int getSize() throws javax.mail.MessagingException;
    public   int getLineCount() throws javax.mail.MessagingException;
    public   java.lang.String getContentType() throws javax.mail.MessagingException;
    public   boolean isMimeType(java.lang.String d) throws
javax.mail.MessagingException;
    public   java.lang.String getDisposition() throws javax.mail.MessagingException;
    public   void setDisposition(java.lang.String e) throws
javax.mail.MessagingException;
    public   java.lang.String getDescription() throws javax.mail.MessagingException;
    public   void setDescription(java.lang.String f) throws
javax.mail.MessagingException;
    public   java.lang.String getFileName() throws javax.mail.MessagingException;
    public   void setFileName(java.lang.String f) throws
javax.mail.MessagingException;
    public   java.io.InputStream getInputStream() throws java.io.IOException, javax.mail.MessagingException;
    public   javax.activation.DataHandler getDataHandler() throws javax.mail.MessagingException;
    public   java.lang.Object getContent() throws java.io.IOException, javax.mail.MessagingException;
    public   void setDataHandler(javax.activation.DataHandler d) throws
javax.mail.MessagingException;
    public   void setContent(java.lang.Object e, java.lang.String f)
throws javax.mail.MessagingException;
    public   void setText(java.lang.String f) throws
javax.mail.MessagingException;
    public   void setContent(javax.mail.Multipart f) throws
javax.mail.MessagingException;
    public   void writeTo(java.io.OutputStream s) throws
java.io.IOException, javax.mail.MessagingException;
    public   java.lang.String[] getHeader(java.lang.String f) throws
javax.mail.MessagingException;
    public   void setHeader(java.lang.String f, java.lang.String g)
throws javax.mail.MessagingException;
    public   void addHeader(java.lang.String h, java.lang.String f)
throws javax.mail.MessagingException;
    public   void removeHeader(java.lang.String g) throws
javax.mail.MessagingException;
    public   java.util.Enumeration getAllHeaders() throws javax.mail.MessagingException;
    public   java.util.Enumeration getMatchingHeaders(java.lang.String[] 
h) throws javax.mail.MessagingException;
    public   java.util.Enumeration
getNonMatchingHeaders(java.lang.String[] g) throws
javax.mail.MessagingException;
}
