package momoko.forum;

import javax.mail.*;
import java.rmi.RemoteException;
import momoko.*;
import java.util.*;
import java.text.DateFormat;
import momoko.forum.*;
import momoko.forum.User;
import momoko.forum.Session;
import java.io.*;
import momoko.server.*;
import momoko.user.*;
import momoko.client.*;

public class getUserDb implements Module
{
  Database db=null;
  IMObject avatar=null;
  IMObject world=null;
  IRegistry registry=null;
  Forum forum=null;
  IClientSideInterface me=(IClientSideInterface)new ClientSideInterface();
  String name="God";
  String pass="God";
  IMObject sb=null;
  IMObject opening=null;
  IMObject users=null;

  static public void main(String[] args) throws Exception
  {
    getUserDb gdb = new getUserDb();
    gdb.initialize(new Properties());
    gdb.populateUserDb();
  }

  public getUserDb()
  {
  }

  public void shutdown() {}

  public void initialize(Properties args)
  {
      if(Database.main==null) Database.main=new Database();
      db=Database.main;
      Database.client=true;
      db.initialize();

      Database.main.setHostname("localhost");

      try
      {
        sb=new momoko.straw.StrawBundel("straws");
        Database.main.move(sb, db.root);
        opening=sb.resolve("localhost");
        registry = (IRegistry) opening.resolve("registry");
        avatar=(IMObject)registry.register(me,name,pass);
        world=opening.resolve("God+God");
        System.out.println("world "+world);
        users=world.resolve("db");
        System.out.println("users: "+users);
        populateUserDb();
      }
      catch(Exception e) {e.printStackTrace();}
  }

  public void populateUserDb() throws Exception
  {
    Vector v=ForumUserDatabase.getUsers();
    Enumeration iterator=v.elements();
    while(iterator.hasMoreElements())
    {
      Hashtable h =(Hashtable)iterator.nextElement();
      String name=(String)h.get("Username");
      String pass=(String)h.get("Password");
      User user=new GenericUser(name);
      user.setPassword(pass);
      Database.main.move(user, users);
    }  
  }
}
