package momoko.proxy;

import momoko.*;
import momoko.proxy.*;
import java.rmi.RemoteException;
import java.util.*;
import java.io.IOException;
import java.lang.reflect.*;

public class Annotating extends MObject
{
  static public boolean debug=false;

  public Annotating()
  {
    this("");
  }

  public Annotating(String name)
  {
    super(name);
  }

  public void enterfunc(IMObject object)
  {
    try {
    subdir.remove(object.getName());
    subdir.put(object.getName(), makeAnnotation(object));
    } catch(Exception e) {e.printStackTrace();}
  }


    public Object makeAnnotation(IMObject obj)
    {
      Class[] i, i2;
      if(debug) System.out.println("Making annotation for "+obj);
      i=obj.getClass().getInterfaces();
      i2=new Class[i.length+1];
      int x;
      for(x=0; x<i.length; x++)
      {
        i2[x]=i[x];
        if(debug) System.out.println("Has interface "+i[x]);
      }
      i2[x]=Annotated.class;
      if(debug) System.out.println("Annotating.makeAnnotation("+obj+")");
      try
      {
      InvocationHandler o=new AnnotationProxy(obj, i2);
      if(debug) System.out.println("new annotation proxy: "+o);
      return java.lang.reflect.Proxy.newProxyInstance(
        obj.getClass().getClassLoader(), i2, o);
      }
      catch(Exception e)
      { e.printStackTrace(); return null; }
    }
}
