package momoko.relationship;
import java.util.*;
import momoko.*;

/**
 *  removes object in subject in the local directory tree
 */
public class DirectoryRemovePredicate implements Predicate
{
  public void execute(Object subject, Object object)
  {
    IMObject s=(IMObject)subject;
    IMObject o=(IMObject)object;

    if(s==null)
    {
      System.out.println("You're attempting to remove an object with no location!");
      return;
    }
    if(o==null)
    {
      System.out.println("You're attempting to remove a null object!");
      return;
    }

    s.remove(o.getName());
  }
}  
