package momoko.scheduler;

import momoko.*;
import java.util.*;

public class DumpDatabaseTask extends GenericTask
{
  public DumpDatabaseTask()
  {
    this("");
  }

  public DumpDatabaseTask(String name)
  {
    super(name);
    TimerTask t=new MyTask();
    setTask(t);
    setPeriod(600000);
  }

  private class MyTask extends TimerTask
  {
    public void run()
    {
      System.out.println("Dumping database");
      try { Database.main.root.persistSelf(); }
      catch(Exception e) {e.printStackTrace();}
    }
  }
}
