package momoko.scheduler;

import momoko.*;
import momoko.stream.*;
import momoko.protoclass.*;
import momoko.relationship.*;
import momoko.proxy.*;
import momoko.vfs.*;
import momoko.user.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.vfs.*;
import java.lang.reflect.*;
import java.beans.*;
import momoko.versioncontrol.*;

public class GenericScheduler extends MObject implements Scheduler
{
  Timer timer=new Timer();

/**
 *  create a new object without a name
 */
public GenericScheduler()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public GenericScheduler(String newname)
{
  namestr=newname;
}

public boolean accept(IMObject object)  
{
  return object instanceof Task;
}

public void enterfunc(IMObject object)
{
  Task t=(Task)object;
  TimerTask task=t.getTask();
  long period=t.getPeriod();
  timer.schedule(task, 0, period);
}
public void exitfunc(IMObject object)
{
  Task t=(Task)object;
  TimerTask task=t.getTask();
  task.cancel();
}

}
