package momoko.types;

import java.util.*;
import momoko.*;
import java.lang.reflect.*;

public class MudArray extends Vector
{
  String type;

  public MudArray()
  {
    super();
    type="Integer";
  }

  public MudArray(String value)
  {
    super(fromString(value));
    int i;
    i=value.indexOf(':');
    type=value.substring(0,i);
  }

  static private Vector fromString(String value)
  {
      try{
      int i;
      i=value.indexOf(':');
      System.out.println("Array member type found at "+i+value);
      if(i==-1) return null;
      String mtype=value.substring(0,i);
      System.out.println("Array member type is "+mtype);
      value=value.substring(i+1,value.length());
      Class mclass=(Class)Database.main.types.named(mtype);
      System.out.println(mclass);
      Class[] caar=new Class[1];
      caar[0]=Class.forName("java.lang.String");
      Constructor con=mclass.getConstructor(caar);
      Object[] oaar=new Object[1];
      StringTokenizer st=new StringTokenizer(value, "[,] ", true);
      String token;
      Stack stk=new Stack();
      while(st.hasMoreTokens())
      {
        System.out.println("#:"+stk);
        token=st.nextToken();
        if(token.equals(",")) continue;
        if(token.equals(" ")) continue;
        if(token.equals("["))
        {
          System.out.println("new array");
          stk.push(new Vector());
        }
        else if(token.equals("]"))
        {
          System.out.println("end of array");

          Object c=stk.pop();
          try
          {
            ((Vector)stk.peek()).addElement(c);
          }
          catch(EmptyStackException e)
          {
            stk.push(c);
          }
        }
        else
        {
          System.out.println("member of array");
          oaar[0]=token;
	  try{((Vector)stk.peek()).addElement(con.newInstance(oaar));}
          catch(EmptyStackException e){}
        }
      }
      System.out.println("stacksize: "+stk.size());
      if(stk.size()==1)
        return (Vector)stk.pop();
      else
        return null;
      }
      catch(Exception e) {e.printStackTrace(); return null;}
    }

  public String toString()
  {
    return type+":"+super.toString();
  }
}
