package momoko.vfs;

import java.io.*;

public class RealFile extends File implements VirtualFile
{
    public RealFile(String s) {super(s);}
    public RealFile(File f, String s) {super(f, s);}

    public InputStream getInputStream()
    {
      try { return new FileInputStream(this); }
      catch(Exception e)
      {
        e.printStackTrace();
        return null;
      }
    }

    public OutputStream getOutputStream()
    {
      try { return new FileOutputStream(this); }
      catch(Exception e)
      {
        e.printStackTrace();
        return null;
      }
    }
}
